package ru.neroduckale;

import net.fabricmc.api.ModInitializer;

import net.fabricmc.fabric.api.networking.v1.ServerPlayNetworking;
import net.minecraft.util.Hand;
import net.minecraft.util.Identifier;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import ru.neroduckale.register.*;
import ru.neroduckale.vapes.Vape;

public class NeroduckaleVapes implements ModInitializer {
    public static final Logger LOGGER = LoggerFactory.getLogger("nerovapes");
    public static final String MOD_ID = "nerovapes";
    

    @Override
    public void onInitialize() {
        RegisterGUI.registerGUIs();
        RegisterItems.registerModItems();
        RegisterItemGroup.registerItemGroups();
        RegisterSounds.registerSounds();
        RegisterParticles.registerParticles();
        LOGGER.info("Hello Fabric world!");
        ServerPlayNetworking.registerGlobalReceiver(new Identifier("nerovapes", "ring"), (server, player, handler, buf, responseSender) -> {
            server.execute(() -> {
                if (player.getStackInHand(Hand.MAIN_HAND).getItem() instanceof Vape vape) {
                    vape.newRing(player, server.getOverworld());
                }
            });
        });
        
    }
}