package ru.neroduckale.fluids;

import net.minecraft.client.item.TooltipContext;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NbtCompound;
import net.minecraft.text.Text;
import net.minecraft.util.Hand;
import net.minecraft.util.TypedActionResult;
import net.minecraft.world.World;
import org.jetbrains.annotations.Nullable;

import java.util.List;

public class ExampleFluid extends Item {
    public String jija;

    public ExampleFluid(Settings settings, String jija) {
        super(settings.maxDamage(300));
        this.jija = jija;
    }

    @Override
    public void inventoryTick(ItemStack stack, World world, Entity entity, int slot, boolean selected) {
        if (!stack.getNbt().contains("amountjija")) {
            var nbt = new NbtCompound();
            nbt.putInt("amountjija", 300);
            stack.setNbt(nbt);
            stack.setDamage(300);
        }

        stack.setDamage(stack.getMaxDamage() - stack.getNbt().getInt("amountjija"));

    }

    @Override
    public void appendTooltip(ItemStack stack, @Nullable World world, List<Text> tooltip, TooltipContext context) {
        tooltip.add(Text.of(this.jija));
        tooltip.add(Text.of("Жижи осталось: %s мл".formatted(((float) stack.getNbt().getInt("amountjija") / 10))));
    }


}
