package ru.neroduckale.gui;

import com.mojang.blaze3d.systems.RenderSystem;
import net.fabricmc.fabric.api.client.rendering.v1.HudRenderCallback;
import net.minecraft.client.MinecraftClient;
import net.minecraft.client.gui.DrawContext;
import net.minecraft.entity.boss.BossBar;
import net.minecraft.item.ItemStack;
import net.minecraft.util.Colors;
import net.minecraft.util.Hand;
import net.minecraft.util.Identifier;
import net.minecraft.util.math.ColorHelper;
import net.minecraft.util.math.MathHelper;
import ru.neroduckale.vapes.Vape;

public class HudRemainingTime implements HudRenderCallback {
    private static final Identifier BARS_TEXTURE = new Identifier("textures/gui/bars.png");
    private static final int WIDTH = 182;
    private static final int HEIGHT = 5;
    
    
    @Override
    public void onHudRender(DrawContext drawContext, float tickDelta) {
        if (MinecraftClient.getInstance().player == null) {
            return;
        }
        if (MinecraftClient.getInstance().player.getStackInHand(Hand.MAIN_HAND).getItem() instanceof Vape) {
            if (MinecraftClient.getInstance().player.getActiveHand().equals(Hand.MAIN_HAND)) {
                int i = drawContext.getScaledWindowWidth();
                int j = 12;
                int k = i / 2 - 91;
                this.renderBossBar(drawContext, k, j, MinecraftClient.getInstance().player.getStackInHand(Hand.MAIN_HAND));
                
                
                
                
            }
        }
    }

    private void renderBossBar(DrawContext context, int x, int y, ItemStack itemStack) {
        var vape = (Vape) itemStack.getItem();
        this.renderBossBar(context, x, y, itemStack, 182, 0, false);
        this.renderBossBar(context, x, y, itemStack, vape.getPercent(itemStack), 5, true);
    }

    private void renderBossBar(DrawContext context, int x, int y, ItemStack itemStack, int width, int height, boolean solid) {
        if (width == 0 && solid) {
            context.drawTexture(BARS_TEXTURE, x, y, 0, 20, 182, 5);
            return;
        }
        context.drawTexture(BARS_TEXTURE, x, y, 0, 10, width, 5);
        if (solid) {
            context.drawTexture(BARS_TEXTURE, x, y, 0, 15, width, 5);
        }
        
    }
}
