package ru.neroduckale.gui;

import com.mojang.blaze3d.systems.RenderSystem;
import net.minecraft.client.gui.DrawContext;
import net.minecraft.client.gui.screen.ingame.HandledScreen;
import net.minecraft.client.render.GameRenderer;
import net.minecraft.entity.player.PlayerInventory;
import net.minecraft.text.Text;
import net.minecraft.util.Identifier;
import ru.neroduckale.util.MouseUtil;

public class prikolscreen extends HandledScreen<prikolscreenhandler> {
    //A path to the gui texture. In this example we use the texture from the dispenser
    private static final Identifier TEXTURE = new Identifier("nerovapes", "textures/gui/vapeui.png");
    public prikolscreen(prikolscreenhandler handler, PlayerInventory inventory, Text title) {
        super(handler, inventory, title);
    }

    @Override
    public void render(DrawContext context, int mouseX, int mouseY, float delta) {
        renderBackground(context);
        super.render(context, mouseX, mouseY, delta);
        drawMouseoverTooltip(context, mouseX, mouseY);
    }

    @Override
    protected void init() {
        super.init();
        // Center the title
        titleX = (backgroundWidth - textRenderer.getWidth(title)) / 2;
    }


    @Override
    protected void drawBackground(DrawContext context, float delta, int mouseX, int mouseY) {
        RenderSystem.setShader(GameRenderer::getPositionTexProgram);
        RenderSystem.setShaderColor(1.0F, 1.0F, 1.0F, 1.0F);
        RenderSystem.setShaderTexture(0, TEXTURE);
        int x = (width - backgroundWidth) / 2;
        int y = (height - backgroundHeight) / 2;
        context.drawTexture(TEXTURE, x, y, 0, 0, backgroundWidth, backgroundHeight);
        //in 1.20 or above,this method is in DrawContext class.
        drawFluidAmount(context);
    }
    
    @Override
    public void drawForeground(DrawContext context, int mouseX, int mouseY) {
        int x = (width - backgroundWidth) / 2;
        int y = (height - backgroundHeight) / 2;

        renderEnergyAreaTooltips(context, mouseX, mouseY, x, y);
    }
    
    private void renderEnergyAreaTooltips(DrawContext context, int pMouseX, int pMouseY, int x, int y) {
        if(isMouseAboveArea(pMouseX, pMouseY, x, y, 41, 7, 10, 63)) {
            context.drawTooltip(textRenderer, getTooltips(), pMouseX - x, pMouseY - y);
        }
    }
    private void drawFluidAmount(DrawContext context) {
        int x1 = x + 41; //Начало строки на интерфейсе (Ширина)
        int y1 = y + 7 + 63 - handler.getHeight(); //Начало строки на интерфейсе (Длина)
        int u = 190; //Начало полоски жижи вне интерфейса
        int v = 1 + 63 - handler.getHeight(); //Начало полоски жижи вне интерфейса
        int width = 11;//Ширина полоски вне интерфейса и в интерфейсе
        int height = handler.getHeight();//Длина полоски вне интерфейса и в интерфейсе, при половине 31
        context.drawTexture(TEXTURE, x1, y1, u, v, width, height);
    }

    public Text getTooltips() {
        String a = "Жижи осталось: %s мл".formatted(((float) handler.getAmount()) / 10);
        return Text.of(a);
    }
    private boolean isMouseAboveArea(int pMouseX, int pMouseY, int x, int y, int offsetX, int offsetY, int width, int height) {
        return MouseUtil.isMouseOver(pMouseX, pMouseY, x + offsetX, y + offsetY, width, height);
    }
    
}


