package ru.neroduckale.register;

import net.minecraft.registry.Registries;
import net.minecraft.registry.Registry;
import net.minecraft.sound.SoundEvent;
import net.minecraft.util.Identifier;
import ru.neroduckale.NeroduckaleVapes;

public class RegisterSounds {
    private RegisterSounds() {
        // private empty constructor to avoid accidental instantiation
    }

    // ITEM_METAL_WHISTLE is the name of the custom sound event
    // and is called in the mod to use the custom sound
    public static final SoundEvent VAPE = registerSound("vape");

    // actual registration of all the custom SoundEvents
    private static SoundEvent registerSound(String id) {
        SoundEvent sound = SoundEvent.of(new Identifier(NeroduckaleVapes.MOD_ID, id));
        return Registry.register(Registries.SOUND_EVENT, new Identifier(NeroduckaleVapes.MOD_ID, id), sound);
    }

    // This static method starts class initialization, which then initializes
    // the static class variables (e.g. ITEM_METAL_WHISTLE).
    public static void registerSounds() {
        NeroduckaleVapes.LOGGER.info("Registering " + NeroduckaleVapes.MOD_ID + " Sounds");
        // Technically this method can stay empty, but some developers like to notify
        // the console, that certain parts of the mod have been successfully initialized
    }
}
