package ru.neroduckale.vapes;

import com.zigythebird.playeranimatorapi.API.PlayerAnimAPI;
import dev.kosmx.playerAnim.api.layered.KeyframeAnimationPlayer;
import dev.kosmx.playerAnim.api.layered.modifier.AbstractFadeModifier;
import dev.kosmx.playerAnim.core.data.KeyframeAnimation;
import dev.kosmx.playerAnim.core.util.Ease;
import dev.kosmx.playerAnim.minecraftApi.PlayerAnimationRegistry;

import net.fabricmc.fabric.mixin.event.lifecycle.WorldMixin;
import net.minecraft.entity.Entity;
import net.minecraft.entity.LivingEntity;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.entity.player.PlayerInventory;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NbtCompound;
import net.minecraft.screen.NamedScreenHandlerFactory;
import net.minecraft.screen.ScreenHandler;
import net.minecraft.server.world.ServerWorld;
import net.minecraft.text.Text;
import net.minecraft.util.Hand;
import net.minecraft.util.Identifier;
import net.minecraft.util.TypedActionResult;
import net.minecraft.util.collection.DefaultedList;
import net.minecraft.util.math.Vec3d;
import net.minecraft.world.World;
import org.jetbrains.annotations.Nullable;
import ru.neroduckale.animation.IExampleAnimatedPlayer;
import ru.neroduckale.register.RegisterParticles;
import ru.neroduckale.util.ImplementedInventory;
import ru.neroduckale.fluids.ExampleFluid;
import ru.neroduckale.gui.prikolscreenhandler;
import ru.neroduckale.register.RegisterSounds;
import ru.neroduckale.util.power;

import java.math.BigDecimal;
import java.math.RoundingMode;

public class Vape extends Item implements NamedScreenHandlerFactory, ImplementedInventory {
    public int mlbak;
    public int rasxod;
    public power power;

    private final DefaultedList<ItemStack> inventory = DefaultedList.ofSize(2, ItemStack.EMPTY);

    public Vape(Settings settings, int mlbak, int rasxod, power power) {
        super(settings.maxCount(1));
        this.rasxod = rasxod;
        this.mlbak = mlbak;
        this.power = power;
    }

    
    @Override
    public TypedActionResult<ItemStack> use(World world, PlayerEntity user, Hand hand) {
        if (!world.isClient()) {
            if (user.isInSneakingPose()) {
                user.openHandledScreen(this);
                return TypedActionResult.pass(user.getStackInHand(hand));
            }
            var stack = user.getStackInHand(hand);
            if (stack.getNbt().getInt("amountjija") <= 0) {
                user.sendMessage(Text.of("Жижи нет"), true);
                return TypedActionResult.fail(user.getStackInHand(hand));
            }
            NbtCompound nbt = new NbtCompound();
            nbt.putInt("amountjija", stack.getNbt().getInt("amountjija") - rasxod);
            stack.setNbt(nbt);
            user.setCurrentHand(hand);
            PlayerAnimAPI.playPlayerAnim((ServerWorld) world, user, new Identifier("nerovapes", "vapeup"));
            
        } else {
            var stack = user.getStackInHand(hand);
            if (stack.getNbt().getInt("amountjija") <= 0) {
                user.sendMessage(Text.of("Жижи нет"), true);
                return TypedActionResult.fail(user.getStackInHand(hand));
            }
            if (user.isInSneakingPose()) {
                return TypedActionResult.success(user.getStackInHand(hand));
            }
            user.setCurrentHand(hand);
        }
        user.playSound(RegisterSounds.VAPE, 2f, 1f);
        return TypedActionResult.pass(user.getStackInHand(hand));
    }

    public static void spawnParticles(World world, PlayerEntity user, Vec3d vec3d, int count) {
        var sw = (ServerWorld) world;
        sw.spawnParticles(RegisterParticles.MY_CLOUD, user.getX(), user.getEyeY(), user.getZ(), 0, vec3d.getX(), vec3d.getY(), vec3d.getZ(), 0.1f);
        for (int i = 0; i < count; i++) {
            sw.spawnParticles(RegisterParticles.MY_CLOUD1, user.getX(), user.getEyeY(), user.getZ(), 0, vec3d.getX(), vec3d.getY(), vec3d.getZ(), 0.1f);
        }
    }


    @Override
    public Text getDisplayName() {
        return Text.literal("VAPE UI");
    }

    @Nullable
    @Override
    public ScreenHandler createMenu(int syncId, PlayerInventory playerInventory, PlayerEntity player) {
        return new prikolscreenhandler(syncId, playerInventory, this);
    }

    @Override
    public DefaultedList<ItemStack> getItems() {
        return inventory;
    }

    @Override
    public void inventoryTick(ItemStack stack, World world, Entity entity, int slot, boolean selected) {
        if (!world.isClient()) {
            if (!stack.hasNbt()) {
                NbtCompound nbtCompound = new NbtCompound();
                nbtCompound.putInt("amountjija", mlbak);
                nbtCompound.putInt("usageticks", 60);
                stack.setNbt(nbtCompound);
            }
            if (inventory.get(0) != ItemStack.EMPTY && inventory.get(0).getItem() instanceof ExampleFluid && entity instanceof PlayerEntity user) {
                if (stack.getNbt().getInt("amountjija") != mlbak) { //Если бак в вейпе не полный
                    var fluiditemamount = getAmount(inventory.get(0));
                    var vapefluidamount = getAmount(stack);
                    var amountskokzalit = mlbak - vapefluidamount;
                    if (fluiditemamount >= amountskokzalit) {
                        inventory.get(0).getNbt().putInt("amountjija", fluiditemamount - amountskokzalit);
                        stack.getNbt().putInt("amountjija", vapefluidamount + amountskokzalit);
                        inventory.get(0).setDamage(inventory.get(0).getMaxDamage() - getAmount(inventory.get(0)));
                    } else if (fluiditemamount < amountskokzalit && fluiditemamount != 0) {
                        stack.getNbt().putInt("amountjija", vapefluidamount + fluiditemamount);
                        inventory.get(0).getNbt().putInt("amountjija", 0);
                        inventory.get(0).setDamage(inventory.get(0).getMaxDamage() - getAmount(inventory.get(0)));
                    }
                }
            }
        } else {
            if (entity instanceof PlayerEntity user && user.currentScreenHandler instanceof prikolscreenhandler p) {
                p.amountjija = getAmount(stack);
            }
        }
    }

    public int getAmount(ItemStack stack) {
        return stack.getNbt().getInt("amountjija");
    }

    

    @Override
    public int getMaxUseTime(ItemStack stack) {
        return 2400;
    }

    public void newRing(PlayerEntity user, ServerWorld sw) {
        if (user.getStackInHand(Hand.MAIN_HAND).getNbt().getInt("amountjija") <= 0) {
            user.sendMessage(Text.of("Жижи нет"), true);
            return;
        }
        if (user.getItemCooldownManager().getCooldownProgress(this, 0) != 0) return;
        NbtCompound nbt = new NbtCompound();
        nbt.putInt("amountjija", user.getStackInHand(Hand.MAIN_HAND).getNbt().getInt("amountjija") - rasxod);
        user.getStackInHand(Hand.MAIN_HAND).setNbt(nbt);
        Vec3d vec3d = Vec3d.fromPolar(user.getPitch(), user.getYaw());
        vec3d.multiply(0.03f);
        sw.spawnParticles(RegisterParticles.RING_PARTICLE, user.getX(), user.getEyeY(), user.getZ(), 0, vec3d.getX(), vec3d.getY(), vec3d.getZ(), 0.1f);
        user.getItemCooldownManager().set(this, 20);
    }

    @Override
    public void onStoppedUsing(ItemStack stack, World world, LivingEntity entity, int remainingUseTicks) {
        PlayerEntity user = (PlayerEntity) entity;
        if (!world.isClient()) {
            user.getItemCooldownManager().set(this, 20);
            Vec3d vec3d = Vec3d.fromPolar(user.getPitch(), user.getYaw());
            vec3d.multiply(0.1f);
            float intp = 2400 - remainingUseTicks; // Сколько тиков прошло
            float pizdec = intp / 20; // сколько секунд прошло
            float finallyy = pizdec * power.power;
            spawnParticles(world, user, vec3d, Math.round(finallyy));
            PlayerAnimAPI.stopPlayerAnim((ServerWorld) world, user, new Identifier("nerovapes", "vapeup"));
        }
        stack.getNbt().putInt("usageticks", 60);
    }
    @Override
    public void usageTick(World world, LivingEntity user, ItemStack stack, int remainingUseTicks) {
        int ticks = 2400 - remainingUseTicks; // СКОЛЬКО ТИКОВ ПРОШЛО
        int max = remainingUseTicks - 2340; //СКОЛЬКО ОСТАЛОСЬ ПРИ MAX = 60
        
        if (ticks > 59) {
            if (ticks % 10 == 0) {
                user.damage(world.getDamageSources().fall(), 2);
                
            }
        }
        if (world.isClient) {
            stack.getNbt().putInt("usageticks", max);
        }
    }
    public int getPercent(ItemStack stack) {
        var a = stack.getNbt().getInt("usageticks"); 
        if (a > 60) {
            a = 60;
        } 
        if (a == 0) {
            a = 1;
        }
        
        float one = 60f / a;
        BigDecimal d = new BigDecimal(one);
        d = d.setScale(2, RoundingMode.DOWN);
        float two = 100 / d.floatValue();
        int three = Math.round(two);
        int finalresult = (183 * three) / 100;
        if (finalresult <= 0) finalresult = 0;
        return finalresult;
    }
}